<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="问卷名称" prop="questionnaire  ">
        <el-input
          v-model="queryParams.questionnaire"
          placeholder="请输入问卷名称"
          clearable
          disabled
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="试题类型" prop="cqQuestType">
        <el-select
          v-model="queryParams.cqQuestType"
          placeholder="请选择试题类型"
          clearable
          class="!w-240px"
          @change="handleQuery"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.COURSE_QUESTION_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="试题内容" prop="cqQuestion">
        <el-input
          v-model="queryParams.cqQuestion"
          placeholder="请输入试题内容"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          v-if="tenantId == getTenantId()"
          @click="openSelectQuestionDialog"
          v-hasPermi="['bjdx:course-question:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 添加
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
<!--      <el-table-column label="试题id" align="center" prop="id" width="100px"/>-->
      <el-table-column label="试题类型" align="center" prop="cqQuestType" width="120px">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COURSE_QUESTION_TYPE" :value="scope.row.cqQuestType" />
        </template>
      </el-table-column>
      <el-table-column label="试题内容" align="center" prop="cqQuestion" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestion"></div>
        </template>
      </el-table-column>
      <el-table-column label="试题解析" align="center" prop="cqQuestAnalysis" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestAnalysis"></div>
        </template>
      </el-table-column>
      <el-table-column label="排序" align="center" prop="bqOrder" />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
<!--          <el-button-->
<!--            link-->
<!--            type="primary"-->
<!--            v-if="scope.row.tenantId == getTenantId()"-->
<!--            @click="openForm('update', scope.row.id)"-->
<!--            v-hasPermi="['bjdx:course-question:update']"-->
<!--          >-->
<!--            编辑-->
<!--          </el-button>-->
          <el-button
            link
            type="danger"
            v-if="scope.row.tenantId == getTenantId()"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['bjdx:course-question:delete']"
          >
            删除
          </el-button>
          <el-button
            link
            type="info"
            @click="goToOptionList(scope.row.id, scope.row.cqQuestion)"
            v-hasPermi="['bjdx:course-question:update']"
          >
            选项列表
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 选择试题弹窗 -->
  <el-dialog
    v-model="selectQuestionDialogVisible"
    title="选择试题"
    width="80%"
  >
    <el-form
      class="-mb-15px"
      :model="selectQueryParams"
      ref="selectQueryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="试题类型" prop="cqQuestType">
        <el-select
          v-model="selectQueryParams.cqQuestType"
          placeholder="请选择试题类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.COURSE_QUESTION_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="试题内容" prop="cqQuestion">
        <el-input
          v-model="selectQueryParams.cqQuestion"
          placeholder="请输入试题内容"
          clearable
          @keyup.enter="handleSelectQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleSelectQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetSelectQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="selectLoading" :data="selectList" ref="selectTableRef" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column type="selection" width="55" />
      <el-table-column label="试题类型" align="center" prop="cqQuestType" width="120px">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COURSE_QUESTION_TYPE" :value="scope.row.cqQuestType" />
        </template>
      </el-table-column>
      <el-table-column label="试题内容" align="center" prop="cqQuestion" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestion"></div>
        </template>
      </el-table-column>
      <el-table-column label="试题解析" align="center" prop="cqQuestAnalysis" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestAnalysis"></div>
        </template>
      </el-table-column>
    </el-table>

    <template #footer>
      <span class="dialog-footer">
        <el-button @click="selectQuestionDialogVisible = false">取消</el-button>
        <el-button type="primary" @click="confirmSelectQuestions">确定</el-button>
      </span>
    </template>
  </el-dialog>

  <!-- 表单弹窗：添加/修改 -->
  <CourseQuestionForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { ref, reactive, onMounted } from 'vue'
import { QuestionnaireApi, CourseQuestionVO } from '@/api/bjdx/questionnaire'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { useRoute, useRouter } from 'vue-router'
import { useI18n } from 'vue-i18n'
import CourseQuestionForm from '@/views/bjdx/coursequestion/CourseQuestionForm.vue'
import { getTenantId } from '@/utils/auth'
import { ElButton } from 'element-plus'


/** 课程-试题 列表 */
defineOptions({ name: 'Questionnaire' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<CourseQuestionVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  questionnaireId: undefined, // 试卷id
  questionIds: [], // 题id
  questionnaire: undefined, // 试卷名称
  cqQuestion: undefined, // 试题内容
  cqQuestType: undefined, // 试题类型
})
const tenantId = ref(undefined)
const queryFormRef = ref() // 搜索的表单
const route = useRoute()

// 选择试题弹窗相关
const selectQuestionDialogVisible = ref(false)
const selectLoading = ref(true)
const selectList = ref<CourseQuestionVO[]>([])
const selectQueryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  id: undefined, // 试题id
  questionnaireId: undefined, // 试题id
  questionIds: [], // 试题id
  cqQuestion: undefined, // 试题内容
  cqQuestType: undefined, // 试题类型,
  tenantId: undefined,
})
const selectQueryFormRef = ref()
const selectTableRef = ref()


/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {

    queryParams.questionnaireId = route.query.questionnaireId
    queryParams.questionnaire = route.query.questionnaire
    tenantId.value = route.query.tenantId

    const data = await QuestionnaireApi.getConfigQuest(queryParams)

    console.log(data)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 打开选择试题弹窗 */
const openSelectQuestionDialog = () => {
  selectQuestionDialogVisible.value = true
  selectQueryParams.questionnaireId = route.query.questionnaireId
  getSelectList()
}

/** 查询选择试题列表 */
const getSelectList = async () => {
  selectLoading.value = true
  try {
    const data = await QuestionnaireApi.getConfigQuestNo(selectQueryParams)
    selectList.value = data.list
  } finally {
    selectLoading.value = false
  }
}

/** 选择试题列表搜索按钮操作 */
const handleSelectQuery = () => {
  selectQueryParams.pageNo = 1
  getSelectList()
}

/** 选择试题列表重置按钮操作 */
const resetSelectQuery = () => {
  selectQueryFormRef.value.resetFields()
  handleSelectQuery()
}

/** 确认选择试题 */
const confirmSelectQuestions = async () => {
  const selectedRows = selectTableRef.value?.getSelectionRows() || []
  queryParams.questionIds = selectedRows.map(row => row.id)
  if (queryParams.questionIds.length === 0) {
    message.warning(t('请选择至少一个试题'))
    return
  }
  try {
    await QuestionnaireApi.addConfigQuest(queryParams)
    message.success(t('添加试题成功'))
    selectQuestionDialogVisible.value = false
    getList()
  } catch (error) {
    message.error(t('添加试题失败'))
  }
}
/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    queryParams.questionIds = [id]
    await QuestionnaireApi.delConfigQuest(queryParams)

    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(() => {
  getList()
})

const router = useRouter()

// 跳转选项列表页
const goToOptionList = (id: number, question: String) => {
  router.push({
    name: 'questOption',
    query: { questId: id , question: question}
  })
}
</script>
